{$O+,F+}

{------------------------------------}
{      << NETTEST unit v.1.4 >>      }
{          ⥢ ।         }
{  Portion Copyright Barry Nance,    }
{                    Greg Estabrooks }
{   (c) 1993,1994 ਩ ᨫ     }
{        yura@quest.semsk.su         }
{------------------------------------}

unit NetTest;

interface

var
    IPX_SPX_Entry : pointer;    { 窠 室 IPX/SPX }

function TestShare : boolean;
 {   Share  DOS }

function TestShare2 : boolean;
 {     Share - 㭨ᠫ,
   뢠 ६ 䠩, ॡ  Windows }

function TestWindows : boolean;
 {   稥 । Windows }

function TestNowell : boolean;
 {   Novell WS Shell }

function TestNETBIOS : boolean;
 {   NETBIOS-। }

function TestNetDrive : boolean;
 {   ⥢ ன⢠ }

function TestIPX : boolean;
 {   (㯭) ⮪ IPX }

function TestSPX : boolean;
 {   (㯭) ⮪ SPX }

implementation

uses Dos;

function TestShare;
var
   R : registers;
begin
  R.ax := $1000;
  Intr ($2F,R);
  if R.al <> $FF then TestShare := false
                 else TestShare := true;
end;

{-----------------------}

function TestShare2;
var
  ShareNotInst : byte;
  f : file;
begin
  assign(f,'test.$$$');
  rewrite(f);
  ShareNotInst:=1;
  asm
    mov bx, FileRec(f).Handle
    mov cx, $0000
    mov dx, $0000
    mov si, $0000
    mov di, $0001
    mov ax, $5C00
    int $21
    jnc @@NoError
    dec ShareNotInst
   @@NoError:
   end;
   TestShare2 := ShareNotInst=0;
   close(f);
   erase(f);
end;

{-----------------------}

function TestWindows;
var
   R : registers;
begin
  R.AX := $4680;                        { Win 3.x Standard check }
  Intr($2F,R);                          { Call Int 2F }
  if R.AX <> 0 then                     { if AX = 0 Win in Real mode }
  begin                                 { else check For enhanced mode }
    R.AX := $1600;                      { Win 3.x Enhanced check }
    Intr($2F,R);                        { Call Int 2F }
    if R.AL in [$00,$80,$01,$FF] then   { Check returned value }
    TestWindows := False                { Nope not installed }
    else
    TestWindows := True;                { Yes it is }
  end
  else
  TestWindows := True;                  { Return True }
end;

{-----------------------}

function TestNowell;
var
   R : registers;
   Reply_buffer : array [1..50] of char;
begin
  R.ax := $EA01;
  R.bx := 0;
  R.es := Seg (Reply_buffer);
  R.di := Ofs (Reply_buffer);
  MsDos (R);
  if R.bx = 0 then TestNowell := false
              else TestNowell := true;
end;

{-----------------------}

function TestNETBIOS : boolean;
type
    NCB = record
            NCB_COMMAND,
            NCB_RETCODE,
            NCB_LSN,
            NCB_NUM : byte;
            NCB_BUFER_PTR : pointer;
            NCB_LENGTH : word;
            NCB_CALLNAME,
            NCB_NAME : array [1..16] of byte;
            NCB_RTO,
            NCB_STO : byte;
            POST_FUNC : pointer;
            NCB_LANA_NUM,
            NCB_CMD_CPLT : byte;
            NCB_RESERVER : array [1..14] of byte;
          end;
var
   Test_NCB : NCB;
   Xp : pointer;
   R : registers;
begin
  GetIntVec ($5C,Xp);
  if Xp = nil then begin
                     TestNETBIOS := false;
                     Exit;
                   end;
  FillChar (Test_NCB,SizeOf(Test_NCB),0);
  Test_NCB.NCB_COMMAND := $7F;
  Test_NCB.NCB_CMD_CPLT := $FF;
  R.es := Seg (Test_NCB);
  R.bx := Ofs (Test_NCB);
  R.ax := $1000;
  Intr ($5C,R);
  if Test_NCB.NCB_RETCODE <> $03 then begin
                                        TestNETBIOS := false;
                                        Exit;
                                      end;
  TestNETBIOS := true;
end;

{-----------------------}

function TestNetDrive;
var
   StartDrv : byte;
   R : registers;
   I : byte;
begin
  StartDrv := 3;
  R.Ax := $1500;
  R.Bx := 0;
  Intr ($2F,R);
  if R.Bx <> 0 then StartDrv := R.Cx + R.Bx + 1;
  for I := StartDrv to 26 do begin
    R.Ah := $44;
    R.Al := 9;
    R.Bl := I;
    Intr ($21,R);
    if (R.Dx AND $1000) = $1000 then begin
      TestNetDrive := true;
      Exit;
    end;
  end;
  TestNetDrive := false;
end;

{-----------------------}

function TestIPX;
var
   R : registers;
begin
  R.ax := $7A00;
  Intr ($2F,R);
  if R.al <> $FF then begin
    TestIPX := false;
    Exit;
  end;
  IPX_SPX_Entry := Ptr (R.es,R.di);
  TestIPX := true;
end;

{-----------------------}

function TestSPX;
begin
  asm
    mov bx, $0010               { ⠭ ॣ஢ }
    mov ax, $0000               {  । spx }
    call far [IPX_SPX_Entry]    { 맮 窨 室 ipx_spx }
    mov @Result,al              { 1 - , 0 -  }
  end
end;

begin
  IPX_SPX_Entry := nil;
end.
